const Cell = require('./Cell');

/**
 * @extends {Cell}
 */
class RelayCell extends Cell {
  constructor (circuit_id, cell_command, node, relay_command, stream_id, payload) {
    super(circuit_id, cell_command, null);
    this.node = node;
    this.relay_command = relay_command;
    this.stream_id = stream_id;
    this.relay_payload = payload;
  }
  static fromCell(node, cell) {
    const relay_command  = cell.payload.readUInt8(0);
    const recognized     = cell.payload.readUInt16BE(1);
    const stream_id      = cell.payload.readUInt16BE(3);
    const digest         = cell.payload.readUInt32BE(5);
    const payload_length = cell.payload.readUInt16BE(9);
    const payload = cell.payload.slice(11, 11 + payload_length);

    return new RelayCell(cell.circuit_id, cell.command, node, relay_command, stream_id, payload);
  }
}
module.exports = RelayCell;
