const crypto = require('crypto');
/**
 * @returns {Buffer}
 */
function hmac_sha256(key, data) {
  const h = crypto.createHmac('sha256', key);
  return h.update(data).digest();
}
exports.hmac_sha256 = hmac_sha256;

/**
 * @param {BinaryLike} data
 * @returns {Buffer}
 */
function sha1(data) {
  const h = crypto.createHash('sha1');
  return h.update(data).digest();
}
exports.sha1 = sha1;
